// Generated by rstantools.  Do not edit by hand.

/*
    rts2 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    rts2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with rts2.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_approxlgcp_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_approxlgcp");
    reader.add_event(111, 109, "end", "model_approxlgcp");
    return reader;
}
template <typename T0__>
Eigen::Matrix<typename boost::math::tools::promote_args<T0__>::type, Eigen::Dynamic, 1>
lambda_nD(const std::vector<T0__>& L,
              const std::vector<int>& m,
              const int& D, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 3;
        validate_non_negative_index("lam", "D", D);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> lam(D);
        stan::math::initialize(lam, DUMMY_VAR__);
        stan::math::fill(lam, DUMMY_VAR__);
        current_statement_begin__ = 4;
        for (int i = 1; i <= D; ++i) {
            current_statement_begin__ = 5;
            stan::model::assign(lam, 
                        stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                        pow(((get_base1(m, i, "m", 1) * stan::math::pi()) / (2 * get_base1(L, i, "L", 1))), 2), 
                        "assigning variable lam");
        }
        current_statement_begin__ = 7;
        return stan::math::promote_scalar<fun_return_scalar_t__>(lam);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct lambda_nD_functor__ {
    template <typename T0__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T0__>::type, Eigen::Dynamic, 1>
    operator()(const std::vector<T0__>& L,
              const std::vector<int>& m,
              const int& D, std::ostream* pstream__) const {
        return lambda_nD(L, m, D, pstream__);
    }
};
template <typename T0__, typename T1__, typename T2__>
typename boost::math::tools::promote_args<T0__, T1__, T2__>::type
spd_nD(const T0__& sigma,
           const Eigen::Matrix<T1__, 1, Eigen::Dynamic>& phi,
           const Eigen::Matrix<T2__, Eigen::Dynamic, 1>& w,
           const int& D, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__, T2__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 10;
        local_scalar_t__ S(DUMMY_VAR__);
        (void) S;  // dummy to suppress unused var warning
        stan::math::initialize(S, DUMMY_VAR__);
        stan::math::fill(S, DUMMY_VAR__);
        current_statement_begin__ = 11;
        stan::math::assign(S, (((pow(sigma, 2) * pow(stan::math::sqrt((2 * stan::math::pi())), D)) * prod(phi)) * stan::math::exp((-(0.5) * multiply(elt_multiply(phi, phi), elt_multiply(w, w))))));
        current_statement_begin__ = 13;
        return stan::math::promote_scalar<fun_return_scalar_t__>(S);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct spd_nD_functor__ {
    template <typename T0__, typename T1__, typename T2__>
        typename boost::math::tools::promote_args<T0__, T1__, T2__>::type
    operator()(const T0__& sigma,
           const Eigen::Matrix<T1__, 1, Eigen::Dynamic>& phi,
           const Eigen::Matrix<T2__, Eigen::Dynamic, 1>& w,
           const int& D, std::ostream* pstream__) const {
        return spd_nD(sigma, phi, w, D, pstream__);
    }
};
template <typename T0__, typename T2__>
Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T2__>::type, Eigen::Dynamic, 1>
phi_nD(const std::vector<T0__>& L,
           const std::vector<int>& m,
           const Eigen::Matrix<T2__, Eigen::Dynamic, Eigen::Dynamic>& x, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T2__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 16;
        int c(0);
        (void) c;  // dummy to suppress unused var warning
        stan::math::fill(c, std::numeric_limits<int>::min());
        stan::math::assign(c,cols(x));
        current_statement_begin__ = 17;
        int r(0);
        (void) r;  // dummy to suppress unused var warning
        stan::math::fill(r, std::numeric_limits<int>::min());
        stan::math::assign(r,rows(x));
        current_statement_begin__ = 19;
        validate_non_negative_index("fi", "r", r);
        validate_non_negative_index("fi", "c", c);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> fi(r, c);
        stan::math::initialize(fi, DUMMY_VAR__);
        stan::math::fill(fi, DUMMY_VAR__);
        current_statement_begin__ = 20;
        validate_non_negative_index("fi1", "r", r);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> fi1(r);
        stan::math::initialize(fi1, DUMMY_VAR__);
        stan::math::fill(fi1, DUMMY_VAR__);
        current_statement_begin__ = 21;
        for (int i = 1; i <= c; ++i) {
            current_statement_begin__ = 22;
            stan::model::assign(fi, 
                        stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), 
                        multiply((1 / stan::math::sqrt(get_base1(L, i, "L", 1))), stan::math::sin(divide(multiply((get_base1(m, i, "m", 1) * stan::math::pi()), add(stan::model::rvalue(x, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "x"), get_base1(L, i, "L", 1))), (2 * get_base1(L, i, "L", 1))))), 
                        "assigning variable fi");
        }
        current_statement_begin__ = 24;
        stan::math::assign(fi1, stan::model::rvalue(fi, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(1), stan::model::nil_index_list())), "fi"));
        current_statement_begin__ = 25;
        for (int i = 2; i <= c; ++i) {
            current_statement_begin__ = 26;
            stan::math::assign(fi1, elt_multiply(fi1, stan::model::rvalue(fi, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "fi")));
        }
        current_statement_begin__ = 28;
        return stan::math::promote_scalar<fun_return_scalar_t__>(fi1);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct phi_nD_functor__ {
    template <typename T0__, typename T2__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T2__>::type, Eigen::Dynamic, 1>
    operator()(const std::vector<T0__>& L,
           const std::vector<int>& m,
           const Eigen::Matrix<T2__, Eigen::Dynamic, Eigen::Dynamic>& x, std::ostream* pstream__) const {
        return phi_nD(L, m, x, pstream__);
    }
};
#include <stan_meta_header.hpp>
class model_approxlgcp
  : public stan::model::model_base_crtp<model_approxlgcp> {
private:
        int D;
        int Q;
        std::vector<double> L;
        int M;
        int M_nD;
        int Nsample;
        int nT;
        std::vector<int> y;
        matrix_d x_grid;
        std::vector<std::vector<int> > indices;
        vector_d popdens;
        matrix_d X;
        std::vector<double> prior_lscale;
        std::vector<double> prior_var;
        std::vector<double> prior_linpred_mean;
        std::vector<double> prior_linpred_sd;
        matrix_d PHI;
        vector_d logpopdens;
public:
    model_approxlgcp(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_approxlgcp(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_approxlgcp_namespace::model_approxlgcp";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 32;
            context__.validate_dims("data initialization", "D", "int", context__.to_vec());
            D = int(0);
            vals_i__ = context__.vals_i("D");
            pos__ = 0;
            D = vals_i__[pos__++];
            check_greater_or_equal(function__, "D", D, 1);
            current_statement_begin__ = 33;
            context__.validate_dims("data initialization", "Q", "int", context__.to_vec());
            Q = int(0);
            vals_i__ = context__.vals_i("Q");
            pos__ = 0;
            Q = vals_i__[pos__++];
            check_greater_or_equal(function__, "Q", Q, 1);
            current_statement_begin__ = 34;
            validate_non_negative_index("L", "D", D);
            context__.validate_dims("data initialization", "L", "double", context__.to_vec(D));
            L = std::vector<double>(D, double(0));
            vals_r__ = context__.vals_r("L");
            pos__ = 0;
            size_t L_k_0_max__ = D;
            for (size_t k_0__ = 0; k_0__ < L_k_0_max__; ++k_0__) {
                L[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 35;
            context__.validate_dims("data initialization", "M", "int", context__.to_vec());
            M = int(0);
            vals_i__ = context__.vals_i("M");
            pos__ = 0;
            M = vals_i__[pos__++];
            check_greater_or_equal(function__, "M", M, 1);
            current_statement_begin__ = 36;
            context__.validate_dims("data initialization", "M_nD", "int", context__.to_vec());
            M_nD = int(0);
            vals_i__ = context__.vals_i("M_nD");
            pos__ = 0;
            M_nD = vals_i__[pos__++];
            check_greater_or_equal(function__, "M_nD", M_nD, 1);
            current_statement_begin__ = 37;
            context__.validate_dims("data initialization", "Nsample", "int", context__.to_vec());
            Nsample = int(0);
            vals_i__ = context__.vals_i("Nsample");
            pos__ = 0;
            Nsample = vals_i__[pos__++];
            check_greater_or_equal(function__, "Nsample", Nsample, 1);
            current_statement_begin__ = 38;
            context__.validate_dims("data initialization", "nT", "int", context__.to_vec());
            nT = int(0);
            vals_i__ = context__.vals_i("nT");
            pos__ = 0;
            nT = vals_i__[pos__++];
            current_statement_begin__ = 39;
            validate_non_negative_index("y", "(Nsample * nT)", (Nsample * nT));
            context__.validate_dims("data initialization", "y", "int", context__.to_vec((Nsample * nT)));
            y = std::vector<int>((Nsample * nT), int(0));
            vals_i__ = context__.vals_i("y");
            pos__ = 0;
            size_t y_k_0_max__ = (Nsample * nT);
            for (size_t k_0__ = 0; k_0__ < y_k_0_max__; ++k_0__) {
                y[k_0__] = vals_i__[pos__++];
            }
            current_statement_begin__ = 40;
            validate_non_negative_index("x_grid", "Nsample", Nsample);
            validate_non_negative_index("x_grid", "D", D);
            context__.validate_dims("data initialization", "x_grid", "matrix_d", context__.to_vec(Nsample,D));
            x_grid = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(Nsample, D);
            vals_r__ = context__.vals_r("x_grid");
            pos__ = 0;
            size_t x_grid_j_2_max__ = D;
            size_t x_grid_j_1_max__ = Nsample;
            for (size_t j_2__ = 0; j_2__ < x_grid_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < x_grid_j_1_max__; ++j_1__) {
                    x_grid(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 41;
            validate_non_negative_index("indices", "M_nD", M_nD);
            validate_non_negative_index("indices", "D", D);
            context__.validate_dims("data initialization", "indices", "int", context__.to_vec(M_nD,D));
            indices = std::vector<std::vector<int> >(M_nD, std::vector<int>(D, int(0)));
            vals_i__ = context__.vals_i("indices");
            pos__ = 0;
            size_t indices_k_0_max__ = M_nD;
            size_t indices_k_1_max__ = D;
            for (size_t k_1__ = 0; k_1__ < indices_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < indices_k_0_max__; ++k_0__) {
                    indices[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            current_statement_begin__ = 42;
            validate_non_negative_index("popdens", "(Nsample * nT)", (Nsample * nT));
            context__.validate_dims("data initialization", "popdens", "vector_d", context__.to_vec((Nsample * nT)));
            popdens = Eigen::Matrix<double, Eigen::Dynamic, 1>((Nsample * nT));
            vals_r__ = context__.vals_r("popdens");
            pos__ = 0;
            size_t popdens_j_1_max__ = (Nsample * nT);
            for (size_t j_1__ = 0; j_1__ < popdens_j_1_max__; ++j_1__) {
                popdens(j_1__) = vals_r__[pos__++];
            }
            current_statement_begin__ = 43;
            validate_non_negative_index("X", "(Nsample * nT)", (Nsample * nT));
            validate_non_negative_index("X", "Q", Q);
            context__.validate_dims("data initialization", "X", "matrix_d", context__.to_vec((Nsample * nT),Q));
            X = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>((Nsample * nT), Q);
            vals_r__ = context__.vals_r("X");
            pos__ = 0;
            size_t X_j_2_max__ = Q;
            size_t X_j_1_max__ = (Nsample * nT);
            for (size_t j_2__ = 0; j_2__ < X_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < X_j_1_max__; ++j_1__) {
                    X(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 44;
            validate_non_negative_index("prior_lscale", "2", 2);
            context__.validate_dims("data initialization", "prior_lscale", "double", context__.to_vec(2));
            prior_lscale = std::vector<double>(2, double(0));
            vals_r__ = context__.vals_r("prior_lscale");
            pos__ = 0;
            size_t prior_lscale_k_0_max__ = 2;
            for (size_t k_0__ = 0; k_0__ < prior_lscale_k_0_max__; ++k_0__) {
                prior_lscale[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 45;
            validate_non_negative_index("prior_var", "2", 2);
            context__.validate_dims("data initialization", "prior_var", "double", context__.to_vec(2));
            prior_var = std::vector<double>(2, double(0));
            vals_r__ = context__.vals_r("prior_var");
            pos__ = 0;
            size_t prior_var_k_0_max__ = 2;
            for (size_t k_0__ = 0; k_0__ < prior_var_k_0_max__; ++k_0__) {
                prior_var[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 46;
            validate_non_negative_index("prior_linpred_mean", "Q", Q);
            context__.validate_dims("data initialization", "prior_linpred_mean", "double", context__.to_vec(Q));
            prior_linpred_mean = std::vector<double>(Q, double(0));
            vals_r__ = context__.vals_r("prior_linpred_mean");
            pos__ = 0;
            size_t prior_linpred_mean_k_0_max__ = Q;
            for (size_t k_0__ = 0; k_0__ < prior_linpred_mean_k_0_max__; ++k_0__) {
                prior_linpred_mean[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 47;
            validate_non_negative_index("prior_linpred_sd", "Q", Q);
            context__.validate_dims("data initialization", "prior_linpred_sd", "double", context__.to_vec(Q));
            prior_linpred_sd = std::vector<double>(Q, double(0));
            vals_r__ = context__.vals_r("prior_linpred_sd");
            pos__ = 0;
            size_t prior_linpred_sd_k_0_max__ = Q;
            for (size_t k_0__ = 0; k_0__ < prior_linpred_sd_k_0_max__; ++k_0__) {
                prior_linpred_sd[k_0__] = vals_r__[pos__++];
            }
            // initialize transformed data variables
            current_statement_begin__ = 50;
            validate_non_negative_index("PHI", "Nsample", Nsample);
            validate_non_negative_index("PHI", "M_nD", M_nD);
            PHI = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(Nsample, M_nD);
            stan::math::fill(PHI, DUMMY_VAR__);
            current_statement_begin__ = 51;
            validate_non_negative_index("logpopdens", "(Nsample * nT)", (Nsample * nT));
            logpopdens = Eigen::Matrix<double, Eigen::Dynamic, 1>((Nsample * nT));
            stan::math::fill(logpopdens, DUMMY_VAR__);
            stan::math::assign(logpopdens,stan::math::log(popdens));
            // execute transformed data statements
            current_statement_begin__ = 53;
            for (int m = 1; m <= M_nD; ++m) {
                current_statement_begin__ = 54;
                stan::model::assign(PHI, 
                            stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(m), stan::model::nil_index_list())), 
                            phi_nD(L, stan::model::rvalue(indices, stan::model::cons_list(stan::model::index_uni(m), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "indices"), x_grid, pstream__), 
                            "assigning variable PHI");
            }
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 59;
            validate_non_negative_index("beta", "M_nD", M_nD);
            validate_non_negative_index("beta", "nT", nT);
            num_params_r__ += (M_nD * nT);
            current_statement_begin__ = 60;
            validate_non_negative_index("phi", "D", D);
            num_params_r__ += D;
            current_statement_begin__ = 61;
            num_params_r__ += 1;
            current_statement_begin__ = 62;
            validate_non_negative_index("gamma", "Q", Q);
            num_params_r__ += Q;
            current_statement_begin__ = 63;
            num_params_r__ += 1;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_approxlgcp() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 59;
        if (!(context__.contains_r("beta")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable beta missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("beta");
        pos__ = 0U;
        validate_non_negative_index("beta", "M_nD", M_nD);
        validate_non_negative_index("beta", "nT", nT);
        context__.validate_dims("parameter initialization", "beta", "matrix_d", context__.to_vec(M_nD,nT));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta(M_nD, nT);
        size_t beta_j_2_max__ = nT;
        size_t beta_j_1_max__ = M_nD;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                beta(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(beta);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable beta: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 60;
        if (!(context__.contains_r("phi")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable phi missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("phi");
        pos__ = 0U;
        validate_non_negative_index("phi", "D", D);
        context__.validate_dims("parameter initialization", "phi", "row_vector_d", context__.to_vec(D));
        Eigen::Matrix<double, 1, Eigen::Dynamic> phi(D);
        size_t phi_j_1_max__ = D;
        for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
            phi(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.row_vector_lb_unconstrain(1e-05, phi);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable phi: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 61;
        if (!(context__.contains_r("sigma")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable sigma missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("sigma");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "sigma", "double", context__.to_vec());
        double sigma(0);
        sigma = vals_r__[pos__++];
        try {
            writer__.scalar_lb_unconstrain(1e-05, sigma);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable sigma: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 62;
        if (!(context__.contains_r("gamma")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable gamma missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("gamma");
        pos__ = 0U;
        validate_non_negative_index("gamma", "Q", Q);
        context__.validate_dims("parameter initialization", "gamma", "vector_d", context__.to_vec(Q));
        Eigen::Matrix<double, Eigen::Dynamic, 1> gamma(Q);
        size_t gamma_j_1_max__ = Q;
        for (size_t j_1__ = 0; j_1__ < gamma_j_1_max__; ++j_1__) {
            gamma(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_unconstrain(gamma);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable gamma: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 63;
        if (!(context__.contains_r("ar")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable ar missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("ar");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "ar", "double", context__.to_vec());
        double ar(0);
        ar = vals_r__[pos__++];
        try {
            writer__.scalar_lub_unconstrain(-(1), 1, ar);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable ar: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 59;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> beta;
            (void) beta;  // dummy to suppress unused var warning
            if (jacobian__)
                beta = in__.matrix_constrain(M_nD, nT, lp__);
            else
                beta = in__.matrix_constrain(M_nD, nT);
            current_statement_begin__ = 60;
            Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> phi;
            (void) phi;  // dummy to suppress unused var warning
            if (jacobian__)
                phi = in__.row_vector_lb_constrain(1e-05, D, lp__);
            else
                phi = in__.row_vector_lb_constrain(1e-05, D);
            current_statement_begin__ = 61;
            local_scalar_t__ sigma;
            (void) sigma;  // dummy to suppress unused var warning
            if (jacobian__)
                sigma = in__.scalar_lb_constrain(1e-05, lp__);
            else
                sigma = in__.scalar_lb_constrain(1e-05);
            current_statement_begin__ = 62;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> gamma;
            (void) gamma;  // dummy to suppress unused var warning
            if (jacobian__)
                gamma = in__.vector_constrain(Q, lp__);
            else
                gamma = in__.vector_constrain(Q);
            current_statement_begin__ = 63;
            local_scalar_t__ ar;
            (void) ar;  // dummy to suppress unused var warning
            if (jacobian__)
                ar = in__.scalar_lub_constrain(-(1), 1, lp__);
            else
                ar = in__.scalar_lub_constrain(-(1), 1);
            // transformed parameters
            current_statement_begin__ = 67;
            validate_non_negative_index("f", "(Nsample * nT)", (Nsample * nT));
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> f((Nsample * nT));
            stan::math::initialize(f, DUMMY_VAR__);
            stan::math::fill(f, DUMMY_VAR__);
            current_statement_begin__ = 69;
            validate_non_negative_index("diagSPD", "M_nD", M_nD);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> diagSPD(M_nD);
            stan::math::initialize(diagSPD, DUMMY_VAR__);
            stan::math::fill(diagSPD, DUMMY_VAR__);
            current_statement_begin__ = 70;
            validate_non_negative_index("SPD_beta", "M_nD", M_nD);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> SPD_beta(M_nD);
            stan::math::initialize(SPD_beta, DUMMY_VAR__);
            stan::math::fill(SPD_beta, DUMMY_VAR__);
            // transformed parameters block statements
            current_statement_begin__ = 72;
            for (int m = 1; m <= M_nD; ++m) {
                current_statement_begin__ = 73;
                stan::model::assign(diagSPD, 
                            stan::model::cons_list(stan::model::index_uni(m), stan::model::nil_index_list()), 
                            stan::math::sqrt(spd_nD(sigma, phi, stan::math::sqrt(lambda_nD(L, stan::model::rvalue(indices, stan::model::cons_list(stan::model::index_uni(m), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "indices"), D, pstream__)), D, pstream__)), 
                            "assigning variable diagSPD");
            }
            current_statement_begin__ = 76;
            for (int t = 1; t <= nT; ++t) {
                current_statement_begin__ = 77;
                stan::math::assign(SPD_beta, elt_multiply(diagSPD, stan::model::rvalue(beta, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(t), stan::model::nil_index_list())), "beta")));
                current_statement_begin__ = 78;
                if (as_bool(logical_gt(nT, 1))) {
                    current_statement_begin__ = 79;
                    if (as_bool(logical_eq(t, 1))) {
                        current_statement_begin__ = 80;
                        stan::model::assign(f, 
                                    stan::model::cons_list(stan::model::index_min_max(1, Nsample), stan::model::nil_index_list()), 
                                    multiply(multiply((1 / (1 - pow(ar, 2))), PHI), SPD_beta), 
                                    "assigning variable f");
                    } else {
                        current_statement_begin__ = 82;
                        stan::model::assign(f, 
                                    stan::model::cons_list(stan::model::index_min_max(((Nsample * (t - 1)) + 1), (t * Nsample)), stan::model::nil_index_list()), 
                                    stan::model::deep_copy(add(multiply(ar, stan::model::rvalue(f, stan::model::cons_list(stan::model::index_min_max(((Nsample * (t - 2)) + 1), ((t - 1) * Nsample)), stan::model::nil_index_list()), "f")), multiply(PHI, SPD_beta))), 
                                    "assigning variable f");
                    }
                } else {
                    current_statement_begin__ = 85;
                    stan::model::assign(f, 
                                stan::model::cons_list(stan::model::index_min_max(1, Nsample), stan::model::nil_index_list()), 
                                multiply(PHI, SPD_beta), 
                                "assigning variable f");
                }
            }
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 67;
            size_t f_j_1_max__ = (Nsample * nT);
            for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(f(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: f" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable f: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            current_statement_begin__ = 69;
            size_t diagSPD_j_1_max__ = M_nD;
            for (size_t j_1__ = 0; j_1__ < diagSPD_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(diagSPD(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: diagSPD" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable diagSPD: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            current_statement_begin__ = 70;
            size_t SPD_beta_j_1_max__ = M_nD;
            for (size_t j_1__ = 0; j_1__ < SPD_beta_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(SPD_beta(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: SPD_beta" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable SPD_beta: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            // model body
            current_statement_begin__ = 92;
            lp_accum__.add(normal_log<propto__>(to_vector(beta), 0, 1));
            current_statement_begin__ = 93;
            lp_accum__.add(normal_log<propto__>(phi, get_base1(prior_lscale, 1, "prior_lscale", 1), get_base1(prior_lscale, 2, "prior_lscale", 1)));
            current_statement_begin__ = 94;
            lp_accum__.add(normal_log<propto__>(sigma, get_base1(prior_var, 1, "prior_var", 1), get_base1(prior_var, 2, "prior_var", 1)));
            current_statement_begin__ = 95;
            lp_accum__.add(normal_log<propto__>(ar, 0, 1));
            current_statement_begin__ = 96;
            for (int q = 1; q <= Q; ++q) {
                current_statement_begin__ = 97;
                lp_accum__.add(normal_log<propto__>(get_base1(gamma, q, "gamma", 1), get_base1(prior_linpred_mean, q, "prior_linpred_mean", 1), get_base1(prior_linpred_sd, q, "prior_linpred_sd", 1)));
            }
            current_statement_begin__ = 100;
            lp_accum__.add(poisson_log_log<propto__>(y, add(add(multiply(X, gamma), logpopdens), f)));
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("beta");
        names__.push_back("phi");
        names__.push_back("sigma");
        names__.push_back("gamma");
        names__.push_back("ar");
        names__.push_back("f");
        names__.push_back("diagSPD");
        names__.push_back("SPD_beta");
        names__.push_back("y_grid_predict");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dims__.push_back(M_nD);
        dims__.push_back(nT);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(D);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(Q);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((Nsample * nT));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(M_nD);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(M_nD);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((Nsample * nT));
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_approxlgcp_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta = in__.matrix_constrain(M_nD, nT);
        size_t beta_j_2_max__ = nT;
        size_t beta_j_1_max__ = M_nD;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                vars__.push_back(beta(j_1__, j_2__));
            }
        }
        Eigen::Matrix<double, 1, Eigen::Dynamic> phi = in__.row_vector_lb_constrain(1e-05, D);
        size_t phi_j_1_max__ = D;
        for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
            vars__.push_back(phi(j_1__));
        }
        double sigma = in__.scalar_lb_constrain(1e-05);
        vars__.push_back(sigma);
        Eigen::Matrix<double, Eigen::Dynamic, 1> gamma = in__.vector_constrain(Q);
        size_t gamma_j_1_max__ = Q;
        for (size_t j_1__ = 0; j_1__ < gamma_j_1_max__; ++j_1__) {
            vars__.push_back(gamma(j_1__));
        }
        double ar = in__.scalar_lub_constrain(-(1), 1);
        vars__.push_back(ar);
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            // declare and define transformed parameters
            current_statement_begin__ = 67;
            validate_non_negative_index("f", "(Nsample * nT)", (Nsample * nT));
            Eigen::Matrix<double, Eigen::Dynamic, 1> f((Nsample * nT));
            stan::math::initialize(f, DUMMY_VAR__);
            stan::math::fill(f, DUMMY_VAR__);
            current_statement_begin__ = 69;
            validate_non_negative_index("diagSPD", "M_nD", M_nD);
            Eigen::Matrix<double, Eigen::Dynamic, 1> diagSPD(M_nD);
            stan::math::initialize(diagSPD, DUMMY_VAR__);
            stan::math::fill(diagSPD, DUMMY_VAR__);
            current_statement_begin__ = 70;
            validate_non_negative_index("SPD_beta", "M_nD", M_nD);
            Eigen::Matrix<double, Eigen::Dynamic, 1> SPD_beta(M_nD);
            stan::math::initialize(SPD_beta, DUMMY_VAR__);
            stan::math::fill(SPD_beta, DUMMY_VAR__);
            // do transformed parameters statements
            current_statement_begin__ = 72;
            for (int m = 1; m <= M_nD; ++m) {
                current_statement_begin__ = 73;
                stan::model::assign(diagSPD, 
                            stan::model::cons_list(stan::model::index_uni(m), stan::model::nil_index_list()), 
                            stan::math::sqrt(spd_nD(sigma, phi, stan::math::sqrt(lambda_nD(L, stan::model::rvalue(indices, stan::model::cons_list(stan::model::index_uni(m), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "indices"), D, pstream__)), D, pstream__)), 
                            "assigning variable diagSPD");
            }
            current_statement_begin__ = 76;
            for (int t = 1; t <= nT; ++t) {
                current_statement_begin__ = 77;
                stan::math::assign(SPD_beta, elt_multiply(diagSPD, stan::model::rvalue(beta, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(t), stan::model::nil_index_list())), "beta")));
                current_statement_begin__ = 78;
                if (as_bool(logical_gt(nT, 1))) {
                    current_statement_begin__ = 79;
                    if (as_bool(logical_eq(t, 1))) {
                        current_statement_begin__ = 80;
                        stan::model::assign(f, 
                                    stan::model::cons_list(stan::model::index_min_max(1, Nsample), stan::model::nil_index_list()), 
                                    multiply(multiply((1 / (1 - pow(ar, 2))), PHI), SPD_beta), 
                                    "assigning variable f");
                    } else {
                        current_statement_begin__ = 82;
                        stan::model::assign(f, 
                                    stan::model::cons_list(stan::model::index_min_max(((Nsample * (t - 1)) + 1), (t * Nsample)), stan::model::nil_index_list()), 
                                    stan::model::deep_copy(add(multiply(ar, stan::model::rvalue(f, stan::model::cons_list(stan::model::index_min_max(((Nsample * (t - 2)) + 1), ((t - 1) * Nsample)), stan::model::nil_index_list()), "f")), multiply(PHI, SPD_beta))), 
                                    "assigning variable f");
                    }
                } else {
                    current_statement_begin__ = 85;
                    stan::model::assign(f, 
                                stan::model::cons_list(stan::model::index_min_max(1, Nsample), stan::model::nil_index_list()), 
                                multiply(PHI, SPD_beta), 
                                "assigning variable f");
                }
            }
            if (!include_gqs__ && !include_tparams__) return;
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            // write transformed parameters
            if (include_tparams__) {
                size_t f_j_1_max__ = (Nsample * nT);
                for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
                    vars__.push_back(f(j_1__));
                }
                size_t diagSPD_j_1_max__ = M_nD;
                for (size_t j_1__ = 0; j_1__ < diagSPD_j_1_max__; ++j_1__) {
                    vars__.push_back(diagSPD(j_1__));
                }
                size_t SPD_beta_j_1_max__ = M_nD;
                for (size_t j_1__ = 0; j_1__ < SPD_beta_j_1_max__; ++j_1__) {
                    vars__.push_back(SPD_beta(j_1__));
                }
            }
            if (!include_gqs__) return;
            // declare and define generated quantities
            current_statement_begin__ = 104;
            validate_non_negative_index("y_grid_predict", "(Nsample * nT)", (Nsample * nT));
            Eigen::Matrix<double, Eigen::Dynamic, 1> y_grid_predict((Nsample * nT));
            stan::math::initialize(y_grid_predict, DUMMY_VAR__);
            stan::math::fill(y_grid_predict, DUMMY_VAR__);
            // generated quantities statements
            current_statement_begin__ = 106;
            for (int i = 1; i <= (Nsample * nT); ++i) {
                current_statement_begin__ = 107;
                stan::model::assign(y_grid_predict, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                            stan::math::exp(((multiply(stan::model::rvalue(X, stan::model::cons_list(stan::model::index_uni(i), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "X"), gamma) + get_base1(logpopdens, i, "logpopdens", 1)) + get_base1(f, i, "f", 1))), 
                            "assigning variable y_grid_predict");
            }
            // validate, write generated quantities
            current_statement_begin__ = 104;
            size_t y_grid_predict_j_1_max__ = (Nsample * nT);
            for (size_t j_1__ = 0; j_1__ < y_grid_predict_j_1_max__; ++j_1__) {
                vars__.push_back(y_grid_predict(j_1__));
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_approxlgcp";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t beta_j_2_max__ = nT;
        size_t beta_j_1_max__ = M_nD;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t phi_j_1_max__ = D;
        for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "phi" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma";
        param_names__.push_back(param_name_stream__.str());
        size_t gamma_j_1_max__ = Q;
        for (size_t j_1__ = 0; j_1__ < gamma_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "gamma" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "ar";
        param_names__.push_back(param_name_stream__.str());
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t f_j_1_max__ = (Nsample * nT);
            for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "f" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t diagSPD_j_1_max__ = M_nD;
            for (size_t j_1__ = 0; j_1__ < diagSPD_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "diagSPD" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t SPD_beta_j_1_max__ = M_nD;
            for (size_t j_1__ = 0; j_1__ < SPD_beta_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "SPD_beta" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
        size_t y_grid_predict_j_1_max__ = (Nsample * nT);
        for (size_t j_1__ = 0; j_1__ < y_grid_predict_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "y_grid_predict" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t beta_j_2_max__ = nT;
        size_t beta_j_1_max__ = M_nD;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t phi_j_1_max__ = D;
        for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "phi" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma";
        param_names__.push_back(param_name_stream__.str());
        size_t gamma_j_1_max__ = Q;
        for (size_t j_1__ = 0; j_1__ < gamma_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "gamma" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "ar";
        param_names__.push_back(param_name_stream__.str());
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t f_j_1_max__ = (Nsample * nT);
            for (size_t j_1__ = 0; j_1__ < f_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "f" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t diagSPD_j_1_max__ = M_nD;
            for (size_t j_1__ = 0; j_1__ < diagSPD_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "diagSPD" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t SPD_beta_j_1_max__ = M_nD;
            for (size_t j_1__ = 0; j_1__ < SPD_beta_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "SPD_beta" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
        size_t y_grid_predict_j_1_max__ = (Nsample * nT);
        for (size_t j_1__ = 0; j_1__ < y_grid_predict_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "y_grid_predict" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
    }
}; // model
}  // namespace
typedef model_approxlgcp_namespace::model_approxlgcp stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
#endif
